﻿using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Identity;
using System.Data;
using System.Data.SqlClient;

namespace LoginApp.Models
{
    public class Person
    {
        public int PersonId { get; set; }
        public string FullName { get; set; }
        public string EMail { get; set; }
        public string Password { get; set; }


        public void CreateUser(string connectionString, Person person)
        {
            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("CreateUser", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@FullName", person.FullName));
                    cmd.Parameters.Add(new SqlParameter("@EMail", person.EMail));
                    cmd.Parameters.Add(new SqlParameter("@Password", person.Password));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }

        }

        public bool CheckPassword(string connectionString, string userName, string password)
        {
            string passwordDB = null;

            bool loggedIn = false;

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select Password from PERSON where EMail='" + userName + "'";

            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    passwordDB = dr["Password"].ToString();
                }
            }

            PasswordHasher<string> pw = new PasswordHasher<string>();

            var verificationResult = pw.VerifyHashedPassword(userName, passwordDB, password);

            if (verificationResult == PasswordVerificationResult.Success)
                loggedIn = true;
            else
                loggedIn = false;

            return loggedIn;
        }

        public Person GetUserData(string connectionString, string userName)
        {
            Person person = new Person();

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select PersonId, FullName, EMail from PERSON where EMail='" + userName + "'";

            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    person.PersonId = Convert.ToInt32(dr["PersonId"]);
                    person.FullName = dr["FullName"].ToString();
                    person.EMail = dr["EMail"].ToString();
                }
            }

            return person;
        }

        public void UpdateUser(string connectionString, Person person)
        {
            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("UpdateUser", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@PersonId", person.PersonId));
                    cmd.Parameters.Add(new SqlParameter("@FullName", person.FullName));
                    cmd.Parameters.Add(new SqlParameter("@EMail", person.EMail));
                    cmd.Parameters.Add(new SqlParameter("@Password", person.Password));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

    }
}